package com.im.easemob;

import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Created by kevin.bai on 2018/6/12.
 */

public class EasemobPackage implements ReactPackage {
    public EasemobPackage() {
    }

    public EasemobPackage(EaseMobHookDelegate delegate) {
        EasemobHelper.getInstance().setHookDelegate(delegate);
    }

    @Override
    public List<NativeModule> createNativeModules(ReactApplicationContext reactContext) {
        return Arrays.<NativeModule>asList(
                new ChatManager(reactContext),
                new ClientModule(reactContext),
                new GroupManager(reactContext),
                new PushManager(reactContext)
        );
    }

    public List<Class<? extends JavaScriptModule>> createJSModules() {
        return Collections.emptyList();
    }

    @Override
    public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
        return Collections.emptyList();
    }
}
